#NoTrayIcon
#include <Crypt.au3>
#include <File.au3>
#include <Array.au3>
FileDelete ("crypt.txt")
$version = "3.0"
; Parameter: Quelle, Ziel, Algo, Passwort, Lschen/Behalten (1/0), Verschlsseln/Entschlsseln (1/0)
#cs

0 = Kein Fehler
A1 = Quelldatei/-ordner existiert nicht
A2 = Zieldatei/-ordner existiert bereits
A3 = Datei beschdigt
A4 = Datei veraltet
C1 - Fehler beim Erstellen des Schlssels
C2 - Fehler beim ffnen der Quelldatei
C3 - Fehler beim ffnen der Zieldatei
C4 - Fehler beim Verschlsseln des letzten Stcks der Datei
C5 - Fehler beim Verschlsseln eines Stcks der Datei
D1 - Fehler beim Erstellen des Schlssels
D2 - Fehler beim ffnen der Quelldatei
D3 - Fehler beim ffnen der Zieldatei
D4 - Fehler beim Entschlsseln des letzten Stcks der Datei
D5 - Fehler beim Entschlsseln eines Stcks der Datei

#ce

If $CmdLine[0] = 6 Then
	$quelle = $CmdLine[1]
	$ziel = $CmdLine[2]
	$algo = $CmdLine[3]
	$pw = $CmdLine[4]
	$loeschen = $CmdLine[5]
	$modus = $CmdLine[6]
Else
	MsgBox (16,"Fehlerhafte Parameterbergabe","Es wurden fehlerhafte Parameter bergeben, die Verschlsselung kann nicht durchgefhrt werden. ->" & @CRLF & $CmdLineRaw)
	_ArrayDisplay ($CmdLine)
	Exit
EndIf

If Not FileExists ($quelle) Then _error ("A1")
;If FileExists ($ziel) Then _error ("A2")

If $modus = 1 Then ; Verschlsseln
	$random = @TempDir & "\" & Random (10000000,99999999,1) & ".zip"
	RunWait ('7z.exe a "' & $random & '" "' & $quelle & '"',@ScriptDir,@SW_HIDE)
	Sleep (1000)
	_Crypt_EncryptFile ($random,$ziel,$pw,$algo)
	If @error Then
		$fehler = @error
		_Delete ($ziel)
		_Delete ($random)
		_error ("C" & $fehler)
	Else
		_Delete ($random)
		FileWrite ($ziel,@CRLF & $version & ";" & $algo)
		If $loeschen = 1 Then
			_Delete ($quelle)
			_error (0,@CRLF & "Die Quelle wurde erfolgreich verschlsselt und gelscht.")
		Else
			_error (0,@CRLF & "Die Quelle wurde erfolgreich verschlsselt.")
		EndIf
	EndIf
Else ; Entschlsseln
	$letztezeile = FileReadLine($quelle,-1)
	$array=StringSplit ($letztezeile, ";")
	If Not IsArray ($array) Then _error ("A3")

	If StringLeft ($array[1],1) <> StringLeft ($version,1) Then _error ("A4")
	$algo = $array[2]
	$random = @TempDir & "\" & Random (10000000,99999999,1) & ".zip"
	$filealt = FileRead ($quelle)
	FileWrite (@TempDir & "\crypt.tmp",StringReplace ($filealt,@CRLF & $letztezeile,""))
	_Crypt_DecryptFile (@TempDir & "\crypt.tmp",$random,$pw,$algo)
	Sleep (1000)
	_Delete (@TempDir & "\crypt.tmp")
	If @error Then
		$fehler = @error
		_Delete ($ziel)
		_Delete ($random)
		_error ("D" & $fehler)
	EndIf
	RunWait ('7z.exe x "' & $random & '"',$ziel,@SW_HIDE)
	Sleep (1000)
	If $loeschen = 1 Then
		_Delete ($quelle)
		_Delete ($random)
		_error (0,@CRLF & "Die Quelle wurde erfolgreich entschlsselt und gelscht.")
	Else
		_Delete ($random)
		_error (0,@CRLF & "Die Quelle wurde erfolgreich entschlsselt.")
	EndIf

EndIf





Func _error ($Fehlercode, $extra = "")
	FileWrite (@ScriptDir & "\crypt.txt",$Fehlercode & $extra)
	Exit
EndFunc


; Prft, ob Pfad ein Ordner oder eine Datei ist
Func _DoV($Pfadangabe)
If FileClose(FileOpen($Pfadangabe)) = 0 Then
    Return "folder" ; Pfad ist ein Ordner
Else
    Return "file" ; Pfad ist eine Datei
EndIf
EndFunc

Func _Delete ($F)
   RunWait ('Eraser.exe -' & _DoV($F) & ' "' & $F & '" -subfolders -method DoD -silent',@ScriptDir,@SW_HIDE)
EndFunc