#NoTrayIcon
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>
#include <File.au3>
#include <GuiEdit.au3>
#include <Crypt.au3>
#include <ProgressConstants.au3>

If IniRead ("crypt.ini","Crypt","Haftungsausschluss",0) = 0 Then
	If MsgBox (1+48+256,"Haftungsausschluss","Bitte lesen Sie den folgenden Text sorgfltig durch." & @CRLF & @CRLF & "Haftungsausschluss" & @CRLF & "Der Autor des Programms Crypt bernimmt in keiner Weise Haftung fr Schden jeder Art, die im Zusammenhang mit der Benutzung, der Installation oder dem Download des Programms Crypt fr Sie oder Dritte entstehen. Sie tragen bei der Verwendung dieses Programms das volle und alleinige Risiko, selbst wenn der Fehler nicht auf fehlerhafte Benutzung Ihrerseits, sondern durch eine mangelhafte Programmierung zurckzufhren ist." & @CRLF & @CRLF & @CRLF & "Mit dem Klick auf 'OK' besttigen Sie im Folgenden, den Haftungsauschluss gelesen, verstanden und akzeptiert zu haben, sollte dies nicht der Fall sein, klicken Sie bitte auf 'Abbrechen'.") = 1 Then
		IniWrite ("crypt.ini","Crypt","Haftungsausschluss",1)
	Else
		MsgBox (16,"Haftungsausschluss","Sie drfen die Software nur nutzen, wenn Sie dem Haftungsausschluss zugestimmt haben. Mchten Sie diesem doch zustimmen, starten Sie das Programm erneut und akzeptieren diesen.")
		Exit
	EndIf
EndIf

$text = ""
Dim $szDrive, $szDir, $szFName, $szExt



If @OSVersion <> "WIN_XP" And @OSVersion <> "WIN_VISTA" And @OSVersion <> "WIN_7" And @OSVersion <> "WIN_8" Then
	MsgBox (16,"Nicht untersttztes Betriebssystem","Das von Ihnen eingesetzte Betriebssystem wird von Crypt nicht untersttzt (untersttzt wird Windows XP, Vista, 7 und 8).")
	Exit
EndIf

If Not @Compiled Then
	$ergaenzung = " Diese Funktion ist nur verfgbar, wenn Crypt in kompilierter Form vorliegt."
Else
	$ergaenzung = ""
EndIf

If @OSVersion = "WIN_XP" Then
	$sendto = @UserProfileDir & "\SendTo\Crypt.lnk"
Else
	$sendto = @AppDataDir & "\Microsoft\Windows\SendTo\Crypt.lnk"
EndIf
$version = "3.0"
$by = "Cheater Dieter"

; GUI -----------------------------------------------------
$HauptGUI = GUICreate("Crypt", 578, 472, -1, -1,-1, $WS_EX_ACCEPTFILES)
GUICtrlCreateTab(8, 104, 561, 361)
GUICtrlCreatePic("Banner.jpg", 8, 8, 564, 91)

; Verschlsseln
GUICtrlCreateTabItem("Verschlsseln")
GUICtrlCreateLabel("Bitte whlen Sie die zu verschlsselnde Datei bzw. den zu verschlsselnden Ordner aus.", 16, 136)
$_vPfad = GUICtrlCreateInput("", 40, 152, 513, 21,$ES_READONLY)
GUICtrlSetState(-1, $GUI_DROPACCEPTED)
GUICtrlSetTip(-1, "Auf dieses Feld lassen sich Dateien" & @CRLF & "einfach per Drag & Drop ziehen.")
$_vDateiwaehlen = GUICtrlCreateButton("Datei whlen...", 64, 176, 89, 25, $WS_GROUP)
$_vOrdnerwaehlen = GUICtrlCreateButton("Ordner whlen", 160, 176, 89, 25, $BS_NOTIFY)
GUICtrlCreateLabel("Bitte geben Sie ein Passwort ein.", 16, 216, 159, 17)
$_vPasswort = GUICtrlCreateInput("", 48, 240, 180, 21, BitOR($ES_PASSWORD,$ES_AUTOHSCROLL))
$_vPasswort2 = GUICtrlCreateInput("", 243, 240, 180, 21, BitOR($ES_PASSWORD,$ES_AUTOHSCROLL))
GUICtrlCreateLabel("Optionen", 24, 352, 47, 17)
$_vLoeschen = GUICtrlCreateCheckbox("Quelldatei/-Ordner nach dem Verschlsseln lschen", 48, 368)
$_vModus = GUICtrlCreateCombo("AES 256 Bit", 48, 304, 161, 25)
GUICtrlSetData(-1, "Triple DES|AES 128 Bit|AES 192 Bit|DES 56 Bit|RC2|RC4")
GUICtrlCreateLabel("Bitte whlen Sie eine Verschlsselungsart", 16, 280, 202, 17)
$_vPWzeigen = GUICtrlCreateCheckbox("Passwrter anzeigen", 442, 239)
GUICtrlCreateLabel("Bitte wiederholen Sie das Passwort", 243, 216)

GUICtrlCreateLabel("Bitte whlen Sie einen Ziel fr die verschlsselte Datei", 288, 280, 266, 18)
$_vZiel = GUICtrlCreateInput("", 304, 304, 225, 22,$ES_READONLY)
$_vZielsuchen = GUICtrlCreateButton("...", 536, 304, 22, 22)
$_vStart = GUICtrlCreateButton("Verschlsseln", 32, 416, 497, 33, $WS_GROUP)

; Entschlsseln
$_eTab = GUICtrlCreateTabItem("Entschlsseln")
$_ePfad = GUICtrlCreateInput("", 40, 152, 513, 21,$ES_READONLY)
GUICtrlSetState(-1, $GUI_DROPACCEPTED)
GUICtrlSetTip(-1, "Auf dieses Feld lassen sich Dateien" & @CRLF & "einfach per Drag & Drop ziehen.")
GUICtrlCreateLabel("Bitte whlen Sie die zu entschlsselnde Datei aus.", 16, 136)
$_eDateiwaehlen = GUICtrlCreateButton("Datei whlen...", 64, 176, 89, 25, $WS_GROUP)
GUICtrlCreateLabel("Bitte geben Sie das Passwort ein.", 16, 216, 159, 17)
$_ePasswort = GUICtrlCreateInput("", 48, 240, 193, 21, BitOR($ES_PASSWORD,$ES_AUTOHSCROLL))
GUICtrlCreateLabel("Optionen", 24, 280, 47, 17)
$_eLoeschen = GUICtrlCreateCheckbox("*.crypt-Datei nach dem Entschlsseln lschen", 48, 296)
$_ePWzeigen = GUICtrlCreateCheckbox("Passwort anzeigen", 256, 240, 113, 17)
GUICtrlCreateLabel("Bitte whlen Sie einen Zielordner fr die Entschlsselung", 288, 280)
$_eZiel = GUICtrlCreateInput("", 304, 304, 225, 22,$ES_READONLY)
$_eZielsuchen = GUICtrlCreateButton("...", 536, 304, 22, 22)
$_eStart = GUICtrlCreateButton("Entschlsseln", 32, 416, 497, 33, $WS_GROUP)

; ber
GUICtrlCreateTabItem("ber...")
GUICtrlCreateLabel("ber das Programm" & @CRLF & "Version " & $version & " by " & $by & "." & @CRLF & "Besuchen Sie fr Updates und weitere Informationen die Webseite http://crypt.hegi.tk. Bei Problemen, Fragen und/oder Anregungen knnen Sie gerne eine Mail an crypt@hegi.tk schreiben."& @CRLF & @CRLF & "Mit einer Func von Bob Anthony (_GUICtrlProgressSetMarquee)." & @CRLF & "Fr die Ver- und Entschlsselung von Ordnern wird stellenweise die Kommandozeilenversion der Software 7-Zip verwendet. 7-Zip ist ein ein freies, unter den Bedingungen der LGPL lizenziertes Packprogramm. Weitere Informationen ber 7-Zip erhalten Sie unter www.7-Zip.de." & @CRLF & "Fr das sichere Lschen von Dateien und Ordnern wird ein Teil des Programmes Eraser verwendet, welches unter der GNU General Public License Version 3 steht. Weitere Informationen ber Eraser erhalten Sie unter www.eraser.heidi.ie." & @CRLF & "Die Weitergabe von Crypt ist nur dann erlaubt, wenn diese kostenlos und mit beigelegtem Programmcode erfolgt, sodass jeder Interessierte die Mglichkeit hat, nachzuvollziehen, wie dieses Programm funktioniert. Der Programmcode darf fr private Zwecke beliebig verndert und zerlegt werden, eine Verffentlichung eines modifizierten Codes im Internet ist jedoch nicht gestattet.", 16, 144, 550, 220)
GUICtrlCreateLabel('"Senden an"-Eintrag' & @CRLF & 'Crypt trgt sich auf Wunsch im "Senden an"-Kontextmen ein. Das erlaubt eine schnellere und einfachere Verschlsselung von Dateien und Ordnern.' & $ergaenzung, 16, 370,550,39)
$_eintragen = GUICtrlCreateButton ("Nicht verfgbar",16,415)
sendto ()
If @Compiled Then
	GUICtrlSetState ($_eintragen,$GUI_ENABLE)
Else
	GUICtrlSetState ($_eintragen,$GUI_DISABLE)
EndIf

If $CmdLine[0] <> 0 Then
	_PathSplit($CmdLine[1], $szDrive, $szDir, $szFName, $szExt)
	If $szExt = ".crypt" Then
		GUICtrlSetData ($_ePfad,$CmdLine[1])
		GUICtrlSetState($_eTab,$GUI_SHOW)
	Else
		GUICtrlSetData ($_vPfad,$CmdLine[1])
	EndIf
EndIf

GUISetState()

If IniRead ("crypt.ini","Crypt","Erster Start",0) = 0 Then
	DirRemove (@DesktopDir & "\Crypt Funktionstest")
	MsgBox (64,"Erster Start","Willkommen zu Crypt." & @CRLF & "Dies ist Ihr erster Start des Programms. Um sicherzustellen, dass Crypt auf Ihrem System richtig funktioniert, wird im Folgenden ein kleiner Funktionstest durchgefhrt. Dieser dauert nur einige Sekunden und hilft, Datenverlust zu vermeiden.")
	$_testWarten = GUICreate("Bitte warten Sie einem Moment", 363, 113)
	GUISetBkColor(0xFFFFFF)
	$_testProgress = GUICtrlCreateProgress(8, 48, 345, 25, $PBS_MARQUEE)
	GUICtrlCreateLabel("Bitte warten Sie, whrend der Test luft...", 48, 8, 265, 17)
	GUISetState(@SW_SHOW)
	_GUICtrlProgressSetMarquee ($_testProgress,1,16)
	$hMenu = DllCall("user32.dll", "hwnd", "GetSystemMenu", "hwnd", $_testWarten, "int", 0)
	DllCall("user32.dll", "hwnd", "EnableMenuItem", "hwnd", $hMenu[0], "int", 0xF060, "int", 0x1)

	DirCreate (@DesktopDir & "\Crypt Funktionstest\Dreieck")

	ShellExecuteWait (@ScriptDir & "\c.exe",'"' & @ScriptDir & "\Dreieck und Viereck\Dreieck.jpg" & '" "' & @DesktopDir & "\Crypt Funktionstest\test.crypt" & '" "' & $CALG_AES_256 & '" "test" "0" "1"')
	Sleep (1000)
	ShellExecuteWait (@ScriptDir & "\c.exe",'"' & @DesktopDir & "\Crypt Funktionstest\test.crypt" & '" "' & @DesktopDir & "\Crypt Funktionstest\Dreieck" & '" "' & $CALG_AES_256 & '" "test" "1" "0"')
	Sleep (1000)
	ShellExecuteWait (@ScriptDir & "\c.exe",'"' & @ScriptDir & "\Dreieck und Viereck" & '" "' & @DesktopDir & "\Crypt Funktionstest\test.crypt" & '" "' & $CALG_AES_256 & '" "test" "0" "1"')
	Sleep (1000)
	ShellExecuteWait (@ScriptDir & "\c.exe",'"' & @DesktopDir & "\Crypt Funktionstest\test.crypt" & '" "' & @DesktopDir & "\Crypt Funktionstest" & '" "' & $CALG_AES_256 & '" "test" "1" "0"')
	GUIDelete ($_testWarten)
 	If MsgBox (1,"Funktionstest","Crypt hat nun testweise einige Dateien ver- und wieder entschlsselt. Sie finden auf Ihrem Desktop nun einen Ordner mit dem Namen 'Crypt Funktionstest'. Bitte ffnen Sie diesen Ordner und berprfen, ob" & @CRLF & "1. im Ordner 'Dreieck' die Datei 'Dreieck.jpg' liegt und ob diese ein rotes Dreieck vor grnem Hintergrund zeigt" & @CRLF & "2. Im Ordner 'Dreieck und Viereck' die Dateien 'Dreieck.jpg' und 'Viereck.jpg' liegen und ob diese ein Dreieck bzw. ein Viereck zeigt." & @CRLF & "Ist dies der Fall, so klicken Sie bitte OK, wenn nicht, bitte Abbrechen.") = 1 Then
		MsgBox (64,"Funktionstest","Crypt scheint auf Ihrem System ordnungsgem zu funktionieren. Viel Spa damit!")
		IniWrite ("crypt.ini","Crypt","Erster Start",1)
		DirRemove (@DesktopDir & "\Crypt Funktionstest")
	Else
		MsgBox (64,"Funktionstest","Crypt scheint auf Ihrem System nicht ordnungsgem zu funktionieren. Bitte schreiben Sie eine Mail an 'crypt@hegi.tk'. Ich werde mich dann schnellstmglich um das Problem kmmern. VERSUCHEN SIE NICHT, CRYPT TROTZDEM ZU NUTZEN!")
		Exit
	EndIf

EndIf
While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		; ----------------------------
		Case $GUI_EVENT_CLOSE
			Exit
		; ----------------------------
		Case $_vOrdnerwaehlen
			$folder = FileSelectFolder ("Bitte whlen Sie den zu verschlsselden Ordner","",2)
			GUICtrlSetData ($_vPfad,$folder)
			If $folder = "" Then GUICtrlSetData ($_vPfad,"")
		Case $_vDateiwaehlen
			$file = FileOpenDialog ("Bitte whlen Sie die zu verschlsselnde Datei",@DesktopDir,"Alle Dateien (*.*)",1+2)
			GUICtrlSetData ($_vPfad,$file)
			If $file = "" Then GUICtrlSetData ($_vPfad,"")
		Case $_eDateiwaehlen
			$e_file = FileOpenDialog ("Bitte whlen Sie die zu entschlsselnde Datei",@DesktopDir,"Verschlsselte Dateien (*.crypt)",1+2)
			GUICtrlSetData ($_ePfad,$e_file)
			If $e_file = "" Then
				GUICtrlSetData ($_ePfad,"")
			EndIf

		Case $_eintragen
			If $text = "Eintragen" Then
				$shortcut = FileCreateShortcut (@ScriptFullPath,$sendto,@ScriptDir)
				sendto ()
				If $shortcut = 0 Then
					MsgBox (16,"Fehler",'Das Eintragen ins "Senden an" Kontextmen ist fehlgeschlagen.')
				Else
					MsgBox (64,"Fertig",'Crypt hat sich erfolgreich ins "Senden an"-Kontextmen eingetragen.' & @CRLF & 'Bitte beachten: Wenn Sie Crypt in einen anderen Ordner verschieben, mssen Sie den Eintrag erneut setzten.')
				EndIf
			Else
				$shortcut = FileDelete ($sendto)
				sendto ()
				MsgBox (64,"Fertig",'Crypt hat sich erfolgreich aus dem "Senden an"-Kontextmen ausgetragen.')
			EndIf
		; ---------------------------
		Case $_vZielsuchen
			_PathSplit(GUICtrlRead($_vPfad), $szDrive, $szDir, $szFName, $szExt)
			$gewaehltesziel = FileSaveDialog ("Bitte whlen Sie einen Speicherort.",$szDrive & "\" & $szDir,"Crypt-Dateien (*.crypt)",0,$szFName & $szExt & ".crypt")
			If $gewaehltesziel = "" Then ContinueLoop
			_PathSplit($gewaehltesziel, $szDrive, $szDir, $szFName, $szExt)
			If $szExt = "" Then $gewaehltesziel = $gewaehltesziel & ".crypt"
			GUICtrlSetData ($_vZiel,$gewaehltesziel)
		; -----------------------------
		Case $_eZielsuchen
			_PathSplit(GUICtrlRead($_ePfad), $szDrive, $szDir, $szFName, $szExt)
			$gewaehltesziel2 = FileSelectFolder ("Bitte whlen Sie einen Speicherort.","",7,$szDrive & $szDir)
			If $gewaehltesziel2 = "" Then ContinueLoop
			GUICtrlSetData ($_eZiel,$gewaehltesziel2)
		; ---------------------------------
		Case $_vPWzeigen
			If GUICtrlRead($_vPWzeigen) = $GUI_UNCHECKED Then
				_GUICtrlEdit_SetPasswordChar($_vPasswort, "*")
				_GUICtrlEdit_SetPasswordChar($_vPasswort2, "*")
				GUICtrlSetState($_vPasswort2, $GUI_FOCUS)
				GUICtrlSetState($_vPasswort, $GUI_FOCUS)
			Else
				_GUICtrlEdit_SetPasswordChar($_vPasswort)
				_GUICtrlEdit_SetPasswordChar($_vPasswort2)
				GUICtrlSetState($_vPasswort2, $GUI_FOCUS)
				GUICtrlSetState($_vPasswort, $GUI_FOCUS)
			EndIf
		; ---------------------------------
		Case $_ePWzeigen
			If GUICtrlRead($_ePWzeigen) = $GUI_UNCHECKED Then
				_GUICtrlEdit_SetPasswordChar($_ePasswort, "*")
				GUICtrlSetState($_ePasswort, $GUI_FOCUS)
			Else
				_GUICtrlEdit_SetPasswordChar($_ePasswort)
				GUICtrlSetState($_ePasswort, $GUI_FOCUS)
			EndIf
		; -----------------------------
	Case $_vStart
		FileDelete (@ScriptDir & "\crypt.txt")
			If GUICtrlRead ($_vPfad) = "" Then
				MsgBox (16,"Fehler","Bitte whlen Sie eine Datei oder einen Ordner zum Verschlsseln aus.")
				ContinueLoop
			EndIf
			If GUICtrlRead ($_vZiel) = "" Then
				MsgBox (16,"Fehler","Bitte whlen Sie ein Ziel fr die verschlsselte Datei.")
				ContinueLoop
			EndIf
			If GUICtrlRead ($_vPasswort) = "" Then
				MsgBox (16,"Fehler","Bitte geben Sie ein Passwort ein.")
				ContinueLoop
			EndIf
			If GUICtrlRead ($_vPasswort) <> GUICtrlRead ($_vPasswort2) Then
				MsgBox (16,"Fehler","Das eingebene Passwort und die Wiederholung stimmen nicht berein.")
				ContinueLoop
			EndIf
			If Not FileExists (GUICtrlRead ($_vPfad)) Then
				MsgBox (16,"Fehler","Die zu verschlsselnde Datei existiert nicht.")
				ContinueLoop
			EndIf
			If FileExists (GUICtrlRead ($_vZiel)) Then
				If MsgBox (36,"Warnung","Das Ziel fr die Verschlsselung (die Datei " & GUICtrlRead ($_vZiel) & ") existiert bereits. Soll diese Datei berschrieben werden?") = 6 Then
					FileDelete (GUICtrlRead ($_vZiel))
				Else
					ContinueLoop
				EndIf
			EndIf

			Switch GUICtrlRead($_vModus)
				Case "Triple DES"
					$algo = $CALG_3DES
				Case "DES 56 Bit"
					$algo = $CALG_DES
				Case "RC2"
					$algo = $CALG_RC2
				Case "RC4"
					$algo = $CALG_RC4
				Case "AES 128 Bit"
					$algo = $CALG_AES_128
				Case "AES 192 Bit"
					$algo = $CALG_AES_192
				Case "AES 256 Bit"
					$algo = $CALG_AES_256
				Case Else
					$algo = $CALG_AES_256
			EndSwitch

			If GUICtrlRead($_vLoeschen) = $GUI_CHECKED Then
				$vLoeschen = 1
			Else
				$vLoeschen = 0
			EndIf


			GUISetState (@SW_HIDE,$HauptGUI)

			$_vWarten = GUICreate("Bitte warten Sie einem Moment", 363, 113)
			GUISetBkColor(0xFFFFFF)
			$_vProgress = GUICtrlCreateProgress(8, 48, 345, 25, $PBS_MARQUEE)
			GUICtrlCreateLabel("Bitte warten Sie, whrend die Datei verschlsselt wird...", 48, 8, 265, 17)
			GUICtrlCreateLabel("Dies kann je nach Dateigre einige Zeit in Anspruch nehmen.", 30, 24, 300, 17)
			$_vAbbrechen = GUICtrlCreateButton("Vorgang abbrechen", 120, 80, 123, 25)
			GUISetState(@SW_SHOW)
			_GUICtrlProgressSetMarquee ($_vProgress,1,16)

			$hMenu = DllCall("user32.dll", "hwnd", "GetSystemMenu", "hwnd", $_vWarten, "int", 0)
			DllCall("user32.dll", "hwnd", "EnableMenuItem", "hwnd", $hMenu[0], "int", 0xF060, "int", 0x1)


			ShellExecute (@ScriptDir & "\c.exe",'"' & GUICtrlRead ($_vPfad) & '" "' & GUICtrlRead ($_vZiel) & '" "' & $algo & '" "' & GUICtrlRead ($_vPasswort) & '" "' & $vLoeschen & '" "1"')

			While Not FileExists (@ScriptDir & "\crypt.txt")
				If GUIGetMsg() = $_vAbbrechen Then
					ProcessClose ("c.exe")
					ProcessClose ("7z.exe")
					FileDelete (GUICtrlRead ($_eZiel))
					ExitLoop
				EndIf
			WEnd
			GUIDelete ($_vWarten)
			GUICtrlSetData ($_vPfad,"")
			GUICtrlSetState ($_vLoeschen,$GUI_UNCHECKED)
			GUICtrlSetState ($_vPWzeigen,$GUI_UNCHECKED)
			GUICtrlSetData ($_vZiel,"")
			GUICtrlSetData ($_vPasswort,"")
			GUICtrlSetData ($_vPasswort2,"")

			GUISetState (@SW_SHOW,$HauptGUI)
			$code = FileReadLine (@ScriptDir & "\crypt.txt",1)
			If FileExists (@ScriptDir & "\crypt.txt") Then
				If $code = 0 Then
					MsgBox (64,"Fertig",FileReadLine (@ScriptDir & "\crypt.txt",2))
				Else
					MsgBox (16,"Fehler","Beim Verschlsseln trat ein Fehler auf.")
				EndIf
			EndIf
		; Entschlsseln ---------------
	Case $_eStart
		FileDelete (@ScriptDir & "\crypt.txt")
			If GUICtrlRead ($_ePfad) = "" Then
				MsgBox (16,"Fehler","Bitte whlen Sie eine Datei oder einen Ordner zum Entschlsseln aus.")
				ContinueLoop
			EndIf
			If GUICtrlRead ($_eZiel) = "" Then
				MsgBox (16,"Fehler","Bitte whlen Sie ein Ziel fr die entschlsselte Datei.")
				ContinueLoop
			EndIf
			If GUICtrlRead ($_ePasswort) = "" Then
				MsgBox (16,"Fehler","Bitte geben Sie ein Passwort ein.")
				ContinueLoop
			EndIf
			If Not FileExists (GUICtrlRead ($_ePfad)) Then
				MsgBox (16,"Fehler","Die zu entschlsselnde Datei existiert nicht.")
				ContinueLoop
			EndIf
;			If FileExists (GUICtrlRead ($_eZiel)) Then
;				If MsgBox (36,"Warnung","Das Ziel fr die Entschlsselung (der Ordner " & GUICtrlRead ($_eZiel) & ") existiert bereits. Soll diese Datei berschrieben werden?") = 7 Then FileDelete (GUICtrlRead ($_vZiel))
;				ContinueLoop
;			EndIf

			If GUICtrlRead($_eLoeschen) = $GUI_CHECKED Then
				$eLoeschen = 1
			Else
				$eLoeschen = 0
			EndIf


			GUISetState (@SW_HIDE,$HauptGUI)

			$_eWarten = GUICreate("Bitte warten Sie einem Moment", 363, 113)
			GUISetBkColor(0xFFFFFF)
			$_eProgress = GUICtrlCreateProgress(8, 48, 345, 25, $PBS_MARQUEE)
			GUICtrlCreateLabel("Bitte warten Sie, whrend die Datei verschlsselt wird...", 48, 8, 265, 17)
			GUICtrlCreateLabel("Dies kann je nach Dateigre einige Zeit in Anspruch nehmen.", 30, 24, 300, 17)
			$_eAbbrechen = GUICtrlCreateButton("Vorgang abbrechen", 120, 80, 123, 25)
			GUISetState(@SW_SHOW)
			_GUICtrlProgressSetMarquee ($_eProgress,1,16)

			$hMenu = DllCall("user32.dll", "hwnd", "GetSystemMenu", "hwnd", $_eWarten, "int", 0)
			DllCall("user32.dll", "hwnd", "EnableMenuItem", "hwnd", $hMenu[0], "int", 0xF060, "int", 0x1)


			ShellExecute (@ScriptDir & "\c.exe",'"' & GUICtrlRead ($_ePfad) & '" "' & GUICtrlRead ($_eZiel) & '" "-" "' & GUICtrlRead ($_ePasswort) & '" "' & $eLoeschen & '" "0"')

			While Not FileExists (@ScriptDir & "\crypt.txt")
				If GUIGetMsg() = $_eAbbrechen Then
					ProcessClose ("c.exe")
					ProcessClose ("7z.exe")
					FileDelete (GUICtrlRead ($_eZiel))
					ExitLoop
				EndIf
			WEnd
			GUIDelete ($_eWarten)
			GUICtrlSetData ($_ePfad,"")
			GUICtrlSetState ($_eLoeschen,$GUI_UNCHECKED)
			GUICtrlSetState ($_ePWzeigen,$GUI_UNCHECKED)
			GUICtrlSetData ($_eZiel,"")
			GUICtrlSetData ($_ePasswort,"")

			GUISetState (@SW_SHOW,$HauptGUI)
			$code = FileReadLine (@ScriptDir & "\crypt.txt",1)
			If FileExists (@ScriptDir & "\crypt.txt") Then
				If $code = 0 Then
					MsgBox (64,"Fertig",FileReadLine (@ScriptDir & "\crypt.txt",2))
				Else
					MsgBox (16,"Fehler","Beim Entschlsseln trat der Fehler " & $code & " auf.")
				EndIf
			EndIf

	EndSwitch
WEnd




Func sendto ()
	If FileExists ($sendto) Then
		Global $text = "Austragen"
	Else
		Global $text = "Eintragen"
	EndIf
	GUICtrlSetData ($_eintragen,$text)
EndFunc

;===============================================================================
;
; Function Name:    _GUICtrlProgressSetMarquee()
; Description:    Sets marquee sytle for a progress control
; Parameter(s):  $h_Progress  - The control identifier (controlID)
;               $f_Mode        - Optional: Indicates whether to turn the marquee mode on or off
;                           0 = turn marquee mode off
;                           1 = (Default) turn marquee mode on
;               $i_Time        - Optional: Time in milliseconds between marquee animation updates
;                           Default is 100 milliseconds
; Requirement(s):   AutoIt3 Beta and Windows XP or later
; Return Value(s):  On Success - Returns whether marquee mode is set
;               On Failure - Returns 0  and sets @ERROR = 1
; Author(s):        Bob Anthony
;
;===============================================================================
;
Func _GUICtrlProgressSetMarquee($h_Progress, $f_Mode = 1, $i_Time = 100)

    Local Const $WM_USER = 0x0400
    Local Const $PBM_SETMARQUEE = ($WM_USER + 10)

    Local $var = GUICtrlSendMsg($h_Progress, $PBM_SETMARQUEE, $f_Mode, Number($i_Time))
    If $var = 0 Then
        SetError(1)
        Return 0
    Else
        SetError(0)
        Return $var
    EndIf

EndFunc   ;==>_GUICtrlProgressSetMarquee